//+------------------------------------------------------------------+
//| RSI_Def_WA_mtf                          Waddah_Attar_Def_RSI.mq4 |
//|                              Copyright  2007, Eng. Waddah Attar |
//| mtf:www.forex-tsd.com Keris2112 ml ki    waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, Eng. Waddah Attar"
#property  link      "waddahattar@hotmail.com"
//----
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  Red
#property indicator_width1 2   
#property indicator_width2 1

//----
extern int RSIPeriod1=14;
extern int RSIPeriod2=28;
extern int RSIprice  =0;

extern int SmzPeriod =14;
extern int SmzMode   =0;

double   ind_buffer1[];
double   MABuffer1[];
double   MABuffer1a[];

extern int TimeFrame=0;
extern string note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string Mode_MA_Method  = "SMA0 EMA1 SMMA2 LWMA3";
extern int History = 1500;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
//----   
   SetIndexBuffer(0, ind_buffer1);
   SetIndexBuffer(1, MABuffer1);
   SetIndexBuffer(2, MABuffer1a);
//---- 
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN"; break;
      default : TimeFrameStr="TF0";
   }
   IndicatorShortName("RSI_Del ("+RSIPeriod1+","+RSIPeriod2+")("+SmzPeriod+") ["+TimeFrameStr+"] ");
   if (TimeFrame<Period()) TimeFrame=Period();

  
 //  IndicatorShortName("Waddah Attar Def RSI");
  // Comment("copyright waddahwttar@hotmail.com");

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
//  Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double RSI1,RSI2,Explo;
   
   datetime TimeArray[];
   datetime TimeArray1[];
   
   
   int  limit, i, y=0, counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   
    ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
    ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),TimeFrame); 


   limit = Bars - counted_bars;
   limit = MathMax(limit,TimeFrame/Period());
   limit = MathMin(limit,History);  

//----
 
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

     RSI1 = iRSI(NULL, TimeFrame, RSIPeriod1, RSIprice, y);
     RSI2 = iRSI(NULL, TimeFrame, RSIPeriod2, RSIprice, y);

     MABuffer1[i]  = (RSI1-RSI2);
     MABuffer1a[y] =  MABuffer1[i];
       
 
   }

   for(i=0,y=0;i<limit;i++)

   {
    if (Time[i]<TimeArray1[y]) y++;

      ind_buffer1[i] = iMAOnArray(MABuffer1a,0,SmzPeriod,0,SmzMode,y);
 
    }

   return(0);
}
//+------------------------------------------------------------------+


